scala.tools.nsc

# StandardCompileServer

###
Related Doc: package nsc

#### class StandardCompileServer extends SocketServer

The server part of the fsc offline compiler. It awaits compilation commands and executes them. It caches a compiler instance so that it can respond more quickly.

Source
  CompileServer.scala
Version

  1.0

Linear Supertypes
SocketServer, CompileOutputCommon, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. StandardCompileServer
2. SocketServer
3. CompileOutputCommon
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new StandardCompileServer(fixPort: Int = 0)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from StandardCompileServer to any2stringadd[StandardCompileServer] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (StandardCompileServer, B)

   Implicit information
     This member is added by an implicit conversion from StandardCompileServer to ArrowAssoc[StandardCompileServer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### val BufferSize: Int

   Definition Classes
     SocketServer

7. #### val MaxCharge: Double

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

10. #### lazy val compileSocket: CompileSocket

11. #### def createServerSocket(): ServerSocket

    Attributes
      protected
    Definition Classes
      SocketServer

12. #### def doSession(clientSocket: Socket): Unit

    Definition Classes
      SocketServer

13. #### def echo(msg: String): Unit

    Definition Classes
      CompileOutputCommon

14. #### def ensuring(cond: (StandardCompileServer) ⇒ Boolean, msg: ⇒ Any): StandardCompileServer

    Implicit information
      This member is added by an implicit conversion from StandardCompileServer to Ensuring[StandardCompileServer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: (StandardCompileServer) ⇒ Boolean): StandardCompileServer

    Implicit information
      This member is added by an implicit conversion from StandardCompileServer to Ensuring[StandardCompileServer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean, msg: ⇒ Any): StandardCompileServer

    Implicit information
      This member is added by an implicit conversion from StandardCompileServer to Ensuring[StandardCompileServer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean): StandardCompileServer

    Implicit information
      This member is added by an implicit conversion from StandardCompileServer to Ensuring[StandardCompileServer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

20. #### def fatal(msg: String): Nothing

    Definition Classes
      CompileOutputCommon

21. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

22. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from StandardCompileServer to StringFormat[StandardCompileServer] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

23. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

24. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

25. #### var idleMinutes: Int

    Attributes
      protected
    Definition Classes
      SocketServer

26. #### var in: BufferedReader

    Definition Classes
      SocketServer

27. #### def info(msg: String): Unit

    Definition Classes
      CompileOutputCommon

28. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

29. #### def isMemoryFullEnough(): Boolean

30. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

31. #### def newGlobal(settings: Settings, reporter: Reporter): Global

    Create a new compiler instance

32. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

33. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

34. #### var out: PrintWriter

    Definition Classes
      SocketServer

35. #### lazy val port: Int

    Definition Classes
      SocketServer

36. #### def printMemoryStats(): Unit

37. #### var reporter: ConsoleReporter

38. #### def run(): Unit

    Definition Classes
      SocketServer

39. #### lazy val serverSocket: ServerSocket

    Definition Classes
      SocketServer

40. #### def session(): Unit

    Definition Classes
      StandardCompileServer → SocketServer

41. #### var shutdown: Boolean

    Definition Classes
      StandardCompileServer → SocketServer

42. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

43. #### def timeout(): Unit

    Definition Classes
      StandardCompileServer → SocketServer

44. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

45. #### def unequalSettings(s1: Settings, s2: Settings): Set[Settings.Setting]

    Problematically, Settings are only considered equal if every setting is exactly equal.

    Problematically, Settings are only considered equal if every setting is exactly equal. In fsc this immediately breaks down because the randomly chosen temporary outdirs differ between client and server. Among other things. Long term we could use a meaningful equality; short term I'm just ignoring options which I can see causing a new compiler instance every time and which do not interestingly influence compilation products.

46. #### var verbose: Boolean

    Definition Classes
      StandardCompileServer → CompileOutputCommon

47. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

48. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

49. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

50. #### def warn(msg: String): Unit

    Definition Classes
      CompileOutputCommon

51. #### def →[B](y: B): (StandardCompileServer, B)

    Implicit information
      This member is added by an implicit conversion from StandardCompileServer to ArrowAssoc[StandardCompileServer] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from SocketServer

### Inherited from CompileOutputCommon

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from StandardCompileServer to any2stringadd[StandardCompileServer]

### Inherited by implicit conversion StringFormat from StandardCompileServer to StringFormat[StandardCompileServer]

### Inherited by implicit conversion Ensuring from StandardCompileServer to Ensuring[StandardCompileServer]

### Inherited by implicit conversion ArrowAssoc from StandardCompileServer to ArrowAssoc[StandardCompileServer]

### Ungrouped